/*
 * Copyright (c) 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef lint
static char rcsid[] =
    "@(#) $Header: edrop.c,v 1.1 91/04/17 23:38:32 mccanne Locked $ (LBL)";
#endif

struct dlist {
	int n;
	struct dlist *next;
};

static struct dlist *dfreelist;

static struct dlist *
dalloc()
{
	struct dlist *p = dfreelist;

	if (p != 0)
		dfreelist = p->next;
	else
		p = (struct dlist *)malloc(sizeof(*p));

	return p;
}

/*
 */
int
earlydrop(dp, n)
	struct dlist **dp;
	int n;
{
	struct dlist *p;
	int v = 0;

	while ((p = *dp) != 0) {
		if (n >= p->n) {
			n -= p->n;
			++v;
			*dp = p->next;
			p->next = dfreelist;
			dfreelist = p;
		} else {
			p->n -= n;
			break;
		}
	}
	return v;
}

void
latedrop(dp, n)
	struct dlist **dp;
	int n;
{
	struct dlist *tmp = dalloc();

	while (*dp && n > (*dp)->n) {
		n -= (*dp)->n;
		dp = &(*dp)->next;
	}
	if (*dp)
		(*dp)->n -= n;

	tmp->n = n;
	tmp->next = *dp;
	*dp = tmp;
}

